"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebcamService__Consumer = exports.WebcamService__Producer = void 0;
const soa_client_1 = require("@cross-lab-project/soa-client");
const soa_client_2 = require("@cross-lab-project/soa-client");
const tiny_typed_emitter_1 = require("tiny-typed-emitter");
const ServiceType = 'goldi/webcam';
function checkConfig(config) {
    if (config.serviceType !== ServiceType) {
        //throw Error("Service Configuration needs to be for Webcamservice type");
    }
}
class WebcamService__Producer {
    constructor(track, serviceId) {
        this.serviceType = ServiceType;
        this.serviceDirection = soa_client_1.Producer;
        this.serviceId = serviceId;
        this.track = track;
    }
    getMeta() {
        return {
            serviceId: this.serviceId,
            serviceType: ServiceType,
            serviceDirection: this.serviceDirection,
        };
    }
    setupConnection(connection, serviceConfig) {
        checkConfig(serviceConfig);
        const channel = new soa_client_2.MediaChannel(this.track);
        connection.transmit(serviceConfig, 'video', channel);
    }
}
exports.WebcamService__Producer = WebcamService__Producer;
class WebcamService__Consumer extends tiny_typed_emitter_1.TypedEmitter {
    constructor(serviceId) {
        super();
        this.serviceType = ServiceType;
        this.serviceDirection = soa_client_1.Consumer;
        this.serviceId = serviceId;
    }
    getMeta() {
        return {
            serviceId: this.serviceId,
            serviceType: ServiceType,
            serviceDirection: this.serviceDirection,
        };
    }
    setupConnection(connection, serviceConfig) {
        checkConfig(serviceConfig);
        const channel = new soa_client_2.MediaChannel();
        channel.ontrack = event => this.emit('track', event);
        connection.receive(serviceConfig, 'video', channel);
    }
}
exports.WebcamService__Consumer = WebcamService__Consumer;
//# sourceMappingURL=webcam.js.map