import { Consumer, Producer, } from '@cross-lab-project/soa-client';
import { MediaChannel } from '@cross-lab-project/soa-client';
import { TypedEmitter } from 'tiny-typed-emitter';
const ServiceType = 'goldi/webcam';
function checkConfig(config) {
    if (config.serviceType !== ServiceType) {
        //throw Error("Service Configuration needs to be for Webcamservice type");
    }
}
export class WebcamService__Producer {
    constructor(track, serviceId) {
        this.serviceType = ServiceType;
        this.serviceDirection = Producer;
        this.serviceId = serviceId;
        this.track = track;
    }
    getMeta() {
        return {
            serviceId: this.serviceId,
            serviceType: ServiceType,
            serviceDirection: this.serviceDirection,
        };
    }
    setupConnection(connection, serviceConfig) {
        checkConfig(serviceConfig);
        const channel = new MediaChannel(this.track);
        connection.transmit(serviceConfig, 'video', channel);
    }
}
export class WebcamService__Consumer extends TypedEmitter {
    constructor(serviceId) {
        super();
        this.serviceType = ServiceType;
        this.serviceDirection = Consumer;
        this.serviceId = serviceId;
    }
    getMeta() {
        return {
            serviceId: this.serviceId,
            serviceType: ServiceType,
            serviceDirection: this.serviceDirection,
        };
    }
    setupConnection(connection, serviceConfig) {
        checkConfig(serviceConfig);
        const channel = new MediaChannel();
        channel.ontrack = event => this.emit('track', event);
        connection.receive(serviceConfig, 'video', channel);
    }
}
//# sourceMappingURL=webcam.js.map